@echo off

set OUTPUT_FILE=CodeCoverageProperties.xml
set CODE_COVERAGE_BUILDTOOLKIT=%cd%

REM Check for the 'buildtoolkit' directory 
cd ..
set TOOLKIT_DIR=buildtoolkit
IF EXIST %TOOLKIT_DIR% GOTO DIR_EXISTS

REM The directory structure of the build toolkit offering changed in the 3.x version. 
REM Check for the 3.x directory structure if we haven't found the buildtoolkit directory yet
cd ..
set TOOLKIT_DIR=jazz\buildsystem\buildtoolkit
IF NOT EXIST %TOOLKIT_DIR% GOTO NO_BUILDTOOLKIT_DIR

:DIR_EXISTS
REM Directory for the IBM Rational Team Concert Build System Toolkit installation.
cd %TOOLKIT_DIR%
set BUILDTOOLKIT=%cd%

:NO_BUILDTOOLKIT_DIR
cd %CODE_COVERAGE_BUILDTOOLKIT%

for /f "delims= tokens=1" %%c in ('dir /B /S /OD "com.ibm.rational.llc.engine_*"') do set ENGINE_JAR=%%c

REM Determine the JVMTI library to use.
REM Check if an argument was passed to require a 32 bit JVMTI library to be used.
IF "%1" == "/32" GOTO JVMTI_32BIT
IF EXIST "%CODE_COVERAGE_BUILDTOOLKIT%\64bit" GOTO JVMTI_64BIT

:JVMTI_32BIT
set JVMTI_LIB_PREFIX=32bit
goto JVMTI_LIB_PREFIX_SET

:JVMTI_64BIT
set JVMTI_LIB_PREFIX=64bit

:JVMTI_LIB_PREFIX_SET
IF NOT EXIST "%CODE_COVERAGE_BUILDTOOLKIT%\%JVMTI_LIB_PREFIX%\plugins\org.eclipse.tptp.javaprofiler" (
	echo Cannot find the %CODE_COVERAGE_BUILDTOOLKIT%\%JVMTI_LIB_PREFIX%\plugins\org.eclipse.tptp.javaprofiler directory.
	goto END
)

echo ^<project^> > %OUTPUT_FILE%

IF EXIST "%BUILDTOOLKIT%" (
	echo ^<property name="jazz-build-toolkit" value="%BUILDTOOLKIT%"/^> >> %OUTPUT_FILE%
)

echo ^<property name="code-coverage-ext-dir" value="%CODE_COVERAGE_BUILDTOOLKIT%"/^> >> %OUTPUT_FILE%
echo ^<property name="code-coverage-report-dir" value="${code-coverage-ext-dir}\CodeCoverageReports"/^> >> %OUTPUT_FILE%
echo ^<property name="llc-jvmti-library" value="%CODE_COVERAGE_BUILDTOOLKIT%\%JVMTI_LIB_PREFIX%\plugins\org.eclipse.tptp.javaprofiler\JPIBootLoader"/^> >> %OUTPUT_FILE%
echo ^<property name="llc-engine-plugin" value="%ENGINE_JAR%"/^> >> %OUTPUT_FILE%

echo ^<property name="llc-jvm-arg-jvmti" value="-agentpath:${llc-jvmti-library}=JPIAgent:server=standalone,file=;ProbekitAgent:ext-pk-BCILibraryName=BCIEngProbe,ext-pk-probescript="/^> >> %OUTPUT_FILE%
echo ^<property name="llc-jvm-arg-engine" value="-Xbootclasspath/a:${llc-engine-plugin}"/^> >> %OUTPUT_FILE%
echo ^<property name="llc-jvm-arg-output" value="-Dcoverage.out.file="/^> >> %OUTPUT_FILE%

echo ^<import file="${code-coverage-ext-dir}\CoverageToolkitTaskDefs.xml"/^> >> %OUTPUT_FILE%

IF EXIST "%BUILDTOOLKIT%" (
	echo ^<import file="${jazz-build-toolkit}\BuildToolkitTaskDefs.xml"/^> >> %OUTPUT_FILE%
)

echo ^</project^> >> %OUTPUT_FILE%
echo Code Coverage properties file successfully generated!
echo.

:END